<script setup lang="ts">
import type { BlogAuthor, BlogPage } from '@/types/blog';
import { ref, computed } from 'vue';

const props = defineProps<{
  tabs: {
    header: string;
    bio: string;
    socials: {
      twitter?: string;
      linkedin?: string;
      facebook?: string;
      hackerNews?: string;
      threads?: string;
    };
    posts: BlogPage[];
  }[];
  author: BlogAuthor;
  pagination: { totalPosts: number; total: number; currentPage: number; perPage: number };
}>();

const selectedTab = ref(0);

const showPagination = computed(() => props.pagination?.totalPosts > props.pagination?.perPage);
function onTabChange(value: number) {
  selectedTab.value = value;
}

const emit = defineEmits<{
  (e: 'pageChange', page: number): void;
}>();

const onPageChange = (newPage: number) => {
  emit('pageChange', newPage);
};
</script>

<template>
  <section class="author-tabs">
    <SlpContainer>
      <div ref="targetRef" class="author-tabs__wrapper">
        <div v-if="tabs.length" class="author-tabs__tabs" role="tablist" aria-labelledby="tablist-1">
          <SlpButton
            v-for="(tab, tabIndex) in tabs"
            :id="`author-tabs-tab-${tabIndex}`"
            :key="tab.header"
            ref="tab"
            variant="ghost"
            type="button"
            role="tab"
            :aria-selected="selectedTab == tabIndex"
            :aria-controls="`author-tabs-tabpanel-${tabIndex}`"
            class="author-tabs__tab"
            :class="selectedTab == tabIndex ? 'author-tabs__tab--active' : ''"
            @click="onTabChange(tabIndex)"
          >
            <SlpTypography v-if="tab.header" variant="body1" tag="h3">{{ tab.header }}</SlpTypography>
          </SlpButton>
        </div>

        <div
          v-for="(tab, index) in tabs"
          v-show="index === selectedTab"
          :id="`author-tabs-tabpanel-${index}`"
          :key="`tab-content-${index}`"
          role="tabpanel"
          tabindex="0"
          :aria-labelledby="`author-tabs-tab-${index}`"
          class="author-tabs__content"
          :class="selectedTab == index ? 'author-tabs__content--active' : ''"
        >
          <div v-if="tab.posts">
            <BlogPostGrid :posts="tab.posts" />
            <BlogPagination
              v-if="showPagination"
              :current-page="pagination.currentPage"
              :total-pages="pagination.total"
              @page-change="onPageChange"
            />
          </div>
          <div v-if="tab.bio || tab.socials" class="author-tabs__content">
            <SlpRow class="slp-justify-content-between">
              <SlpColumn v-if="tab.bio" :cols="8">
                <div
                  v-if="tab.bio"
                  class="body"
                  :class="tab.socials ? 'slp-mb-24' : ''"
                  v-html="$md.render(tab.bio)"
                ></div>
              </SlpColumn>
              <SlpColumn :cols="tab.bio ? 3 : 12">
                <div v-if="tab.socials" class="author-tabs__socials">
                  <SlpTypography variant="body1-bold" tag="h3"> Connect with {{ author.name }} </SlpTypography>

                  <div class="slp-flex slp-mt-24">
                    <div v-if="tab.socials.twitter" class="slp-mr-24">
                      <a :href="tab.socials.twitter" data-ga-name="twitter" data-ga-location="body">
                        <img
                          src="https://images.ctfassets.net/r9o86ar0p03f/2BYhQwvU82cFDisA8jlesF/b2ce67ba0c62e8782b68ea2a1e5cf3e4/twitter.svg"
                          alt="twitter"
                        />
                      </a>
                    </div>
                    <div v-if="tab.socials.linkedin" class="slp-mr-24">
                      <a :href="tab.socials.linkedin" data-ga-name="linkedin" data-ga-location="body">
                        <img
                          src="https://images.ctfassets.net/r9o86ar0p03f/3xmFvfzlZvfxZshnWzPsHb/2b54ae2a2345e23ea5a000f582941a8a/linkedin.svg"
                          alt="linkedin"
                        />
                      </a>
                    </div>
                    <div v-if="tab.socials.facebook" class="slp-mr-24">
                      <a :href="tab.socials.facebook" data-ga-name="facebook" data-ga-location="body">
                        <img
                          src="https://images.ctfassets.net/r9o86ar0p03f/2CJEUO4gDZcI1FvwWiQdsf/63d3bf05e5c199ae4e09670b5e54b983/facebook.svg"
                          alt="facebook"
                        />
                      </a>
                    </div>
                    <div v-if="tab.socials.hackerNews" class="slp-mr-24">
                      <a :href="tab.socials.hackerNews" data-ga-name="hackernews" data-ga-location="body">
                        <img
                          src="https://images.ctfassets.net/r9o86ar0p03f/2aY4maRF3ASuJmMi8x1hqo/729dfed40c60f036c9225757857f6623/hackernews.svg"
                          alt="hackernews"
                        />
                      </a>
                    </div>
                    <div v-if="tab.socials.threads" class="slp-mr-24">
                      <a :href="tab.socials.threads" data-ga-name="threads" data-ga-location="body">
                        <img
                          src="https://images.ctfassets.net/r9o86ar0p03f/2fMIkyZeJPULdg8nxYdmsG/b3751a982a7401aeb74d4d6d4226c591/threads.svg"
                          alt="threads"
                        />
                      </a>
                    </div>
                  </div>
                </div>
              </SlpColumn>
            </SlpRow>
          </div>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.author-tabs {
  &__tabs {
    border-bottom: 1px solid #d1d0d3;
  }
  &__tab {
    position: relative;
    overflow: hidden;
    border-radius: 0px;
    padding: 24px;
    &:before {
      content: '';
      display: block;
      position: absolute;
      width: 100%;
      height: 3px;
      background: #7759c2;
      bottom: 0;
      transform: translateX(-100%);
      left: 0;
      transition: all 0.3s ease;
    }
  }
  &__tab--active {
    h3 {
      font-weight: 600;
    }
    &:before {
      transform: translateX(0%);
    }
  }
  &__content {
    padding: 24px 0;
  }
  :deep(.recent-posts) {
    margin-top: 0;
  }
  .body {
    :deep(p) {
      margin: 16px auto;
    }
  }
}
</style>
